<?php
require_once ('../include/inc_mysql.php');

session_start();

$warning = NULL;

if (file_exists('../conf.php')) {
	$title = 'Error...';
	$html = 'There is already a configuration file. You must remove the file \'conf.php\' before continuing.<br />';
	include('include/inc_header.php');
	include('include/inc_text_zone.php');
	include('include/inc_footer.php');
	exit();
}

if (isset($_GET['step']))
	$step = $_GET['step'];
else
	$step = 0;

switch($step) {
case 1:
	$db_selected = NULL;
	$error = false;
	$host = $_POST['host'];
	$username = $_POST['username'];
	$pw = $_POST['pw'];
	$db = $_POST['db'];

	if ($host && $username && $pw && $db) {
		// Let's see if we can connect to the database.
		if($link = @mysql_connect($host, $username, $pw)) {
			// Let's see if we can select the database.
			if ($db_selected = @mysql_select_db($db, $link)) {
				// Save database information
				$_SESSION['cgdl_host'] = $host;
				$_SESSION['cgdl_username'] = $username;
				$_SESSION['cgdl_pass'] = $pw;
				$_SESSION['cgdl_db'] = $db;

				$result = mysql_list_tables($db);

				$duplicate_db = false;
				while ($row = mysql_fetch_row($result)) {
					if($row[0]=='cgd_access' || $row[0]=='cgd_users')
						$duplicate_db = true;
				}

				if ($duplicate_db) {
					// Already installed...
					$warning = 'Coolguys Downloader appears to be already installed in that database. You may wish to use another database, empty manually this database or <a href="setup_en.php?step=2">continue</a> without modifying your database.';
					$error = true;
				} else {
					// Check to see if user can write to database.
					$query = "CREATE TABLE `cgd_access` (
					`id` int(11) unsigned NOT NULL auto_increment,
					`start_date` int(11) unsigned NOT NULL default '0',
					`end_date` int(11) unsigned NOT NULL default '0',
					`uses_left` smallint(4) NOT NULL default '0',
					`hash` varchar(32) default NULL,
					`dir` text,
					`ip` varchar(16) default '0.0.0.0',
					`is_admin` tinyint(1) unsigned NOT NULL default '0',
					`can_create_account` tinyint(1) unsigned NOT NULL default '0',
					`user_account` varchar(20) default NULL,
					UNIQUE KEY `id` (`id`)
					) TYPE=MyISAM AUTO_INCREMENT=2";
					if(mysql_query($query)) {
						// Insert a setup key into database.
						$query = "INSERT INTO `cgd_access` VALUES (1, 0, 4294967295, -1, 'setup', '', '0.0.0.0', 1, 1, null)";
						if(mysql_query($query)) {
							$query = "CREATE TABLE `cgd_users` (
							`id` int(11) unsigned NOT NULL auto_increment,
							`name` varchar(20) default NULL,
							`passwd` varchar(32) default NULL,
							`email` varchar(80) default NULL,
							`dir` text,
							`is_admin` tinyint(1) unsigned NOT NULL default '0',
							UNIQUE KEY `id` (`id`)
							) TYPE=MyISAM AUTO_INCREMENT=1";
							$result = mysql_query($query);
							// All done.
						} else {
							$warning = 'Unable to insert data into table. Double check you have the required permissions to complete this operation.';
							$error = true;
						}
					} else {
						$warning = 'Unable to create table. Double check you have the required permissions to complete this operation.';
						$error = true;
					}
				}
			} else {
				$warning = 'Unable to complete connection to \'' . $db . '\'. You might need to create it.';
				$error = true;
			}
		} else {
			$warning = 'An error occured whilst connecting to the database server.<br />Please double check \'Host\', \'Username\' and \'Password\'.';
			$error = true;
		}
	} else {
		$warning = 'Please fill in all the required fields.';
		$error = true;
	}

	// We're finished with mysql
	if ($db_selected)
		mysql_close();

	if ($error) {
		include('include/inc_header.php');
		include('include/inc_db_setup_en.php');
		include('include/inc_footer.php');
		exit();
	}

	$title = 'Step 1: database setup';
	$html = 'Database setup completed without errors. Move on to <a href="setup_en.php?step=2">step 2</a>.';
	include('include/inc_header.php');
	include('include/inc_text_zone.php');
	include('include/inc_footer.php');
	break;

case 2:
	$uploaddir = dirname(dirname($_SERVER['SCRIPT_FILENAME'])) . '/default_folder/';
	$lang = 'en_US';
	$chmod = '0777';
	include('include/inc_header.php');
	include('include/inc_gen_settings_en.php');
	include('include/inc_footer.php');
	break;

case 3:
	$uploaddir = $_POST['folder'];
	$lang = $_POST['lang'];
	$chmod = $_POST['chmod'];
	if ($uploaddir && $lang && $chmod) {
		$title = 'Setup complete!';

		if (!$handle = @fopen('../conf.php', 'a')) {
			$html = 'Setup was unable to save the configuration file. This is not a problem. Just copy the following text into a new file called \'conf.php\' and upload it to your homepage via FTP.<br /><br />';
			$html .= '&lt;?php<br />$db_access[\'host\'] = \'' . $_SESSION['cgdl_host'] . '\';<br />$db_access[\'username\'] = \'' . $_SESSION['cgdl_username'] . '\';<br />$db_access[\'password\'] = \'' . $_SESSION['cgdl_pass'] . '\';<br />$db_access[\'database\'] = \'' . $_SESSION['cgdl_db'] . '\';<br /><br />$UploadDir = \'' . $uploaddir . '\';<br />$SetDisplayLang = \'' . $lang . '\';<br />$SetChmod = ' . $chmod . ';<br />?&gt;<br /><br />';
			$html .= 'Then <a href="../?key=setup">click here</a> to create an administator account.';
		} else {
			$html = 'Setup is now complete. The configuration file \'conf.php\' was successfully saved and can be edited manually if necessary.<br /><br /><a href="../?key=setup">Click here</a> to create an administator account.';
			$filecontent = "<?php\n\$db_access['host'] = '" . $_SESSION['cgdl_host'] . "';\n\$db_access['username'] = '" . $_SESSION['cgdl_username'] . "';\n\$db_access['password'] = '" . $_SESSION['cgdl_pass'] . "';\n\$db_access['database'] = '" . $_SESSION['cgdl_db'] . "';\n\n\$UploadDir = '" . $uploaddir . "';\n\$SetDisplayLang = '" . $lang . "';\n\$SetChmod = " . $chmod . ";\n?>";
			fwrite($handle, $filecontent);

			// Set permissions otherwise it may not be possible to remove file via ftp
			chmod('../conf.php', 0777);

			fclose($handle);
		}

		include('include/inc_header.php');
		include('include/inc_text_zone.php');
		include('include/inc_footer.php');
	} else {
		$warning = 'Please fill in all the required fields.';
		include('include/inc_header.php');
		include('include/inc_gen_settings_en.php');
		include('include/inc_footer.php');
	}
	break;

default:
	$host = 'localhost';
	$username = 'root';
	$db = 'cg_downloader';
	include('include/inc_header.php');
	include('include/inc_db_setup_en.php');
	include('include/inc_footer.php');
	break;
}
?>